'******************************************
'* NTSC 640 x 480 x 8bpp-lut              *
'* Original 256x192x8 by Chip Gracey      *
'* Modified by Jim Bagley to be 640x480   *
'* VGA from by Andy Schenk, modded by Jim *
'******************************************

CON

'---------------------------------------
' I've not got screen res X or Y done yet with variables, that'll come, you can change the Constants though!

  ResX	 	= 640	'any even amount up to 640
  ResY	 	= 480	'any even amount up to 480
  HIGH_RES	= 1	'if ResX>320 set to 1 ' 0=Low Res in X axis <=320, 1=hi_res in X axis up to 640 pixels.
  INTERLACED	= 1	'if ResY>240 set to 1 ' 0=Low Res in Y axis <=240, 1=Hi Res in Y axis up to 480 pixels.
  BPP		= 8	'Bits Per Pixel, 8 or 32 at the moment.
  DO_VGA	= 1	'VGA or Composite, 0 = Composite, 1 = VGA
  BITMAP_WIDTH	= 640

'---------------------------------------

  HIGH_RES1	= HIGH_RES+1
  INTERLACED1	= INTERLACED+1

'---------------------------------------

  vga_s = 44        'scales DAC output (s = 0..128)

  f_clock	= 50_000_000.0				'clock frequency

  vga_f_scanline= 31_250.0				'scanline frequency
  vga_f_pixel   = vga_f_scanline * float(400<<HIGH_RES)	'pixel frequency for 800 pixels per scanline (12.5 MHz)
  vga_f_xfr     = vga_f_pixel / f_clock * float($7FFF_FFFF)

'---------------------------------------

  s		= 47					'scales DAC output (s = 0..128)
  r		= s * 45 / 128				'adjusts for modulator expansion

  f_color	= 3_579_545.0				'colorburst frequency
  f_scanline	= f_color / 227.5			'scanline frequency
  f_pixel	= f_scanline * float(400<<HIGH_RES)	'pixel frequency for 400 pixels per scanline

  f_xfr		= f_pixel / f_clock * float($7FFF_FFFF)
  f_csc		= f_color / f_clock * float($7FFF_FFFF) * 2.0

'---------------------------------------

DAT		org

'--------------
'This starts off a cog to swap any 32bit images to fix RGB ordering

DAT		org	0

Start		coginit	#1,#@swapbytes
		coginit #0,#@TV_Driver

'--------------

		org	0
swapbytes	cmp	.BitsPP,#32 wz
	if_nz	jmp	#.done		' if not 32bit skip and goto blink

		mov	ptra,##$1000
		mov	.xx,.ImageSize
		shr	.xx,#2
.lp		rdlong	.tmp,ptra	' $00BBGGRR
		shl	.tmp,#8
		wrlong	.tmp,ptra++
		djnz	.xx,#.lp

.done		jmp	#.done

.ImageSize	long	(BPP/8)*BITMAP_WIDTH*ResY
.BitsPP		long	BPP
.tmp		res	1
.xx		res	1

'--------------

		org	0
TV_Driver
		setb	dirb,#0	'make that pin an output
		notb	outb,#0	'flip its output state

		mov	x,#DO_VGA wz
	if_nz	jmp #VGA_Driver
'
' Setup
'

		setxfrq ##round(f_xfr)		'set transfer frequency
		setcfrq	##round(f_csc)		'set colorspace converter frequency
		setcy	mody			'set colorspace converter coefficients
		setci	modi
		setcq	modq
		setcmod	#%11_1_0000		'set colorspace converter to YIQ mode (composite)

'
' Field loop
'
field
		rdfast	#0,##$1000-$400		'load .bmp palette into lut
		mov	x,#0
		rep	@.end,#$100
		rflong	y
		shl	y,#8
		wrlut	y,x
		incmod	x,#$100	wc
.end
	        mov	x,#34-24+((240-(ResY/INTERLACED1))/2)	'top blanks
		call	#blank

		mov	bitmapptr,##$1000

                mov     x,#(ResY/INTERLACED1)'set visible lines
line	        call	#hsync			'do horizontal sync
		rdfast	##0,bitmapptr		'set rdfast to wrap on bitmap
		cmp	BitsPerPixel,#8 wz
	if_z	xcont	m_rf8bit,#0			'visible line (rfword rgb16 (5:6:5)
	if_nz	xcont	m_rf32bit,#0			'visible line (rfword rgb16 (5:6:5)
		add	bitmapptr,linelen
		cmp	is_interlaced,#0 wz
	if_nz	add	bitmapptr,linelen
		djnz    x,#line           	'another line?

                mov     x,#28-24+((240-(ResY/INTERLACED1))/2)	'bottom blanks
		call	#blank

		mov	x,#6			'high vertical syncs
		call	#vsynch
		mov	x,#5			'low vertical syncs
		call	#vsyncl
		mov	x,#5			'high vertical syncs
		call	#vsynch
		tjz	is_interlaced,#field

field2          mov	x,#34-24+((240-(ResY/INTERLACED1))/2)	'top blanks
		call	#blank

		mov	bitmapptr,##$1000
		cmp	is_interlaced,#0 wz
	if_nz	add	bitmapptr,linelen

                mov     x,#(ResY/INTERLACED1)'set visible lines
line2	        call	#hsync			'do horizontal sync
		rdfast	##0,bitmapptr	'set rdfast to wrap on bitmap
		cmp	BitsPerPixel,#8 wz
	if_z	xcont	m_rf8bit,#0			'visible line (rfword rgb16 (5:6:5)
	if_nz	xcont	m_rf32bit,#0			'visible line (rfword rgb16 (5:6:5)
		add	bitmapptr,linelen
		cmp	is_interlaced,#0 wz
	if_nz	add	bitmapptr,linelen
		djnz    x,#line2           	'another line?

                mov     x,#28-24+((240-(ResY/INTERLACED1))/2)	'bottom blanks
		call	#blank

		mov	x,#5			'high vertical syncs
		call	#vsynch
		mov	x,#5			'low vertical syncs
		call	#vsyncl
		mov	x,#4			'high vertical syncs
		call	#vsynch
                jmp     #field                  'loop

'
' Subroutines
'
blank		call	#hsync			'blank lines
		xcont	m_vi,c_border
'		xcont	m_vi,#0
		djnz	x,#blank
		ret

hsync
		cmp	m_bs_border,m_no_border wz
	if_nz	xcont	m_bs_border,c_border
		xcont	m_bs_notborder,#1
'		xcont	m_bs,#1			'horizontal sync
		xcont	m_sn,#2
		xcont	m_bc,#1
		xcont	m_cb,c_cb
'		xcont	m_bv,#1
		xcont	m_bs_notborder,#1
	if_nz	xcont	m_bv_border,c_border
		ret

vsynch		xcont	m_bs,#1			'vertical sync high
		xcont	m_hs,#2
		xcont	m_hl,#1
		djnz	x,#vsynch
		ret

vsyncl		xcont	m_bs,#1			'vertical sync low
		xcont	m_hl,#2
		xcont	m_hs,#1
		djnz	x,#vsyncl
		ret

'
' Initialized data
'
mody		long	((+38*s/128) & $FF) << 24 + ((+75*s/128) & $FF) << 16 + ((+15*s/128) & $FF) << 8 + (110*s/128 & $FF)
modi		long	((+76*r/128) & $FF) << 24 + ((-35*r/128) & $FF) << 16 + ((-41*r/128) & $FF) << 8 + (100*s/128 & $FF)
modq		long	((+27*r/128) & $FF) << 24 + ((-67*r/128) & $FF) << 16 + ((+40*r/128) & $FF) << 8 + 128

m_sn		long	$cf000000+(29<<HIGH_RES)					'sync
m_bc		long	$cf000000+(7<<HIGH_RES)						'before colorburst
m_cb		long	$cf000000+(18<<HIGH_RES)					'colorburst

m_bs		long	$cf000000+((((50-34)<<HIGH_RES) + (((320<<HIGH_RES)-ResX)/2)))	'before sync
m_bv		long	$cf000000+((((40-30)<<HIGH_RES) + (((320<<HIGH_RES)-ResX)/2)))	'before visible
m_vi		long	$cf000000+(ResX)						'visible
m_rf32bit	long	$3f010000+(ResX)						'visible rflong 32bpp
m_rf8bit	long	$7f000000+(ResX)						'visible rflong 8bpp lut

m_bs_notborder	long	$cf000000+((50-34)<<HIGH_RES)	'before sync
m_bv_notborder	long	$cf000000+((40-30)<<HIGH_RES)	'before visible
m_bs_border	long	$cf000000+(((320<<HIGH_RES)-ResX)/2)	'before sync
m_bv_border	long	$cf000000+(((320<<HIGH_RES)-ResX)/2)	'before visible

m_no_border	long	$cf000000	'if m_bs_border = this then no border

BitsPerPixel	long	BPP

m_hs		long	$cf000000+(20<<HIGH_RES)					'vertical sync short
m_hl		long	$cf000000+(130<<HIGH_RES)					'vertical sync long

c_border	long	$000000_00							'Border

c_cb		long	$687800_01							'colorburst reference color
c_vw		long	$FFFF00_00							'white
c_vb		long	$000000_00							'black

x		long	0
y		long	0

is_interlaced	long	INTERLACED

bitmapptr	long	0
linelen		long	BITMAP_WIDTH*(BPP/8)

'--------------- still in driver cog

VGA_Driver
		rdfast	#0,##$1000-$400		'load .bmp palette into lut
		mov	x,#0
		rep	@.end,#$100
		rflong	y
		shl	y,#8
		wrlut	y,x
		incmod	x,#$100	wc
.end
		setxfrq	##round(vga_f_xfr)          'set transfer frequency

		cmp	BitsPerPixel,#8 wz
	if_z	setcy	vga_mody_8                    'set colorspace converter coefficients
	if_z	setci	vga_modi_8
	if_z	setcq	vga_modq_8
	if_nz	setcy	vga_mody_32                   'set colorspace converter coefficients
	if_nz	setci	vga_modi_32
	if_nz	setcq	vga_modq_32

		setcmod	#%01_0_0001             'set colorspace converter for VGA, neg HSync

		setb	dira,#0			'Vsync pin = output
		setb	outa,#0			'and high
'
' Field loop
'
vga_field
		mov	vga_x,#HIGH_RES
		cmp	vga_x,#1 wz
	if_z	jmp	#vga_hi_res
		nop

vga_lo_res	mov	vga_m_bs,vga_lo_res_m_bs
'		add	vga_m_bs,vga_before_lo_res
		mov	vga_m_sn,vga_lo_res_m_sn
		mov	vga_m_bv,vga_lo_res_m_bv
'		add	vga_m_bv,vga_before_lo_res
		mov	vga_m_vi,vga_lo_res_m_vi
		mov	vga_m_border,vga_lo_res_m_border
		mov	vga_m_rf,vga_lo_res_m_rf8
		cmp	BitsPerPixel,#8 wz
	if_nz	mov	vga_m_rf,vga_lo_res_m_rf32
		jmp	#vga_done_settings
		nop
vga_hi_res	mov	vga_m_bs,vga_hi_res_m_bs
'		add	vga_m_bs,vga_before_hi_res
		mov	vga_m_sn,vga_hi_res_m_sn
		mov	vga_m_bv,vga_hi_res_m_bv
'		add	vga_m_bv,vga_before_hi_res
		mov	vga_m_vi,vga_hi_res_m_vi
		mov	vga_m_border,vga_hi_res_m_border
		mov	vga_m_rf,vga_hi_res_m_rf8
		cmp	BitsPerPixel,#8 wz
	if_nz	mov	vga_m_rf,vga_hi_res_m_rf32
vga_done_settings
		cmp	vga_m_border,vga_m_noborder wz

		mov	vga_x,#33+((480-(ResY*(2-INTERLACED)))/2)		'top blanks
                call	#vga_blank

		mov	vga_x,##ResY
		mov	vga_scrp,##$1000
vga_line	mov     vga_y,#2-INTERLACED
.rpt		call	#vga_sync
	if_nz	xcont	vga_m_border,c_border
		rdfast	#0,vga_scrp            'set rdfast to wrap on line
		xcont	vga_m_rf,#0                 'visible line (rflong 8bpp LUT)
	if_nz	xcont	vga_m_border,c_border
		djnz	vga_y,#.rpt                 '4x the same line
		add	vga_scrp,linelen
		djnz	vga_x,#vga_line                 'another line?

		mov	vga_x,#10+((480-(ResY*(2-INTERLACED)))/2)		'bottom blanks
		call	#vga_blank

		clrb	outa,#0                 'do vertical sync (negative)
		mov	vga_x,#2
		call	#vga_blank
		setb	outa,#0

		jmp	#vga_field                  'field loop


vga_blank	call	#vga_sync                   'blank lines
		cmp	vga_m_border,vga_m_noborder wz
	if_nz	xcont	vga_m_border,c_border
		xcont	vga_m_vi,#0
	if_nz	xcont	vga_m_border,c_border
		djnz	vga_x,#vga_blank
		ret

vga_sync
		xcont	vga_m_bs,#0                 'horizontal sync
		xcont	vga_m_sn,#1
		xcont	vga_m_bv,#0
		ret

'
' Initialized data
'
vga_mody_8	long	$01_00_00_00 * vga_s	'red gain
vga_modi_8	long	$00_01_00_00 * vga_s	'green gain
vga_modq_8	long	$00_00_01_00 * vga_s	'blue gain

vga_mody_32	long	$01_00_00_00 * vga_s	'red gain
vga_modi_32	long	$00_01_00_00 * vga_s	'green gain
vga_modq_32	long	$00_00_01_00 * vga_s	'blue gain

vga_lo_res_m_bs		long	$CF000000+8'+((320-ResX)/2)	'before sync
vga_lo_res_m_sn		long	$CF000000+48			'sync
vga_lo_res_m_bv		long	$CF000000+24'+((320-ResX)/2)	'before visible
vga_lo_res_m_vi		long	$CF000000+ResX			'visible
vga_lo_res_m_rf8	long    $7F000000+ResX			'visible rfbyte RGBI
vga_lo_res_m_rf32	long    $3F010000+ResX			'visible rfbyte RGBI
vga_before_lo_res	long	((320-ResX)/2)			'before screen
vga_lo_res_m_border	long	$CF000000+((320-ResX)/2)

vga_hi_res_m_bs		long	$CF000000+8+8'+((640-ResX)/2)	'before sync
vga_hi_res_m_sn		long	$CF000000+48+48			'sync
vga_hi_res_m_bv		long	$CF000000+24+24'+((640-ResX)/2)	'before visible
vga_hi_res_m_vi		long	$CF000000+ResX			'visible
vga_hi_res_m_rf8	long    $7F000000+ResX			'visible rfbyte RGBI
vga_hi_res_m_rf32	long    $3F010000+ResX			'visible rfbyte RGBI
vga_before_hi_res	long	((640-ResX)/2)			'before screen
vga_hi_res_m_border	long    $CF000000+((640-ResX)/2)

vga_m_noborder	long    $CF000000

vga_x		res	1
vga_y		res	1
vga_scrp	res	1

vga_m_bs	res	1		'before sync
vga_m_sn	res	1		'sync
vga_m_bv	res	1		'before visible
vga_m_vi	res	1		'visible
vga_m_rf	res	1		'visible rfbyte RGBI
vga_m_border	res	1


'
' Bitmap
'


LineBuffer	long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff
		long	$ffffffff,$ffffffff,$ffffffff,$ffffffff

'
' 8bit Bitmaps
'
		orgh	$1000 - $436	'justify pixels at $1000, pallete at $1000-$400
'		file	"bubble.bmp"
'		file	"shells.bmp"
'		file	"testcard.bmp"
'		file	"testcard2.bmp"
'		file	"640x480.bmp"
'		file	"Batman-Superman1.bmp"
'		file	"chip.bmp"
'		file	"win95.bmp"
		file	"sddefault.bmp"
'		file	"doom.bmp"	'this is originally a 320x240 image scaled to 640x480
'
' 32bit Bitmaps
'
'		orgh	$1000 - $36	'justify pixels at $1000, pallete at $1000-$400
'		file    "doom32bit.bmp"
'		file    "space.bmp"
'		file    "colour_wheel.bmp"
